> ## Documentation Index > Fetch the complete documentation index at: https://www.canva.dev/docs/apps/llms.txt > Use this file to discover all available pages before exploring further. # Create asset upload job via URL Create an asynchronous job to upload an asset from a URL. Starts a new [asynchronous job](https://www.canva.dev/docs/apps/rest-apis/requests-responses/#asynchronous-job-endpoints) to upload an asset from a URL to the user's content library. Supported file types for assets are listed in the [Assets API overview](https://www.canva.dev/docs/apps/rest-apis/reference/assets/). Uploading a video asset from a URL is limited to a maximum 100MB file size. For importing larger video files, use the [Create asset upload job API](https://www.canva.dev/docs/apps/rest-apis/reference/assets/create-asset-upload-job/). For more information on the workflow for using asynchronous jobs, see [API requests and responses](https://www.canva.dev/docs/apps/rest-apis/requests-responses/#asynchronous-job-endpoints). You can check the status and get the results of asset upload jobs created with this API using the [Get asset upload job via URL API](https://www.canva.dev/docs/apps/rest-apis/reference/assets/get-url-asset-upload-job/). ## HTTP method and URL path POST https\://api.canva.com/rest/v1/url-asset-uploads This operation is rate limited to 30 requests per minute for each user of your app. ## Authentication and authorization This endpoint requires a valid access token that acts on behalf of a user. For more information, see [Generate an access token](/docs/apps/rest-apis/reference/authentication/generate-access-token). ### Scopes The access token must have all the following [scopes](/docs/apps/rest-apis/scopes) (permissions): * `asset:write` ## Header parameters Provides credentials to authenticate the request, in the form of a `Bearer` token. For example: `Authorization: Bearer {token}` Indicates the media type of the information sent in the request. This must be set to `application/json`. For example: `Content-Type: application/json` ## Body parameters A name for the asset. **Minimum length:** `1` **Maximum length:** `255` The URL of the file to import. This URL must be accessible from the internet and be publicly available. **Minimum length:** `8` **Maximum length:** `2048` ## Example request Examples for using the `/v1/url-asset-uploads` endpoint: ```sh curl --request POST 'https://api.canva.com/rest/v1/url-asset-uploads' \ --header 'Authorization: Bearer {token}' \ --header 'Content-Type: application/json' \ --data '{ "name": "My Awesome Asset", "url": "https://example.com/my_asset_to_upload.jpg" }' ``` ```js const fetch = require("node-fetch"); fetch("https://api.canva.com/rest/v1/url-asset-uploads", { method: "POST", headers: { "Authorization": "Bearer {token}", "Content-Type": "application/json", }, body: JSON.stringify({ "name": "My Awesome Asset", "url": "https://example.com/my_asset_to_upload.jpg" }), }) .then(async (response) => { const data = await response.json(); console.log(data); }) .catch(err => console.error(err)); ``` ```java import java.io.IOException; import java.net.URI; import java.net.http.*; public class ApiExample { public static void main(String[] args) throws IOException, InterruptedException { HttpRequest request = HttpRequest.newBuilder() .uri(URI.create("https://api.canva.com/rest/v1/url-asset-uploads")) .header("Authorization", "Bearer {token}") .header("Content-Type", "application/json") .method("POST", HttpRequest.BodyPublishers.ofString("{\"name\": \"My Awesome Asset\", \"url\": \"https://example.com/my_asset_to_upload.jpg\"}")) .build(); HttpResponse response = HttpClient.newHttpClient().send( request, HttpResponse.BodyHandlers.ofString() ); System.out.println(response.body()); } } ``` ```py import requests headers = { "Authorization": "Bearer {token}", "Content-Type": "application/json" } data = { "name": "My Awesome Asset", "url": "https://example.com/my_asset_to_upload.jpg" } response = requests.post("https://api.canva.com/rest/v1/url-asset-uploads", headers=headers, json=data ) print(response.json()) ``` ```csharp using System.Net.Http; var client = new HttpClient(); var request = new HttpRequestMessage { Method = HttpMethod.Post, RequestUri = new Uri("https://api.canva.com/rest/v1/url-asset-uploads"), Headers = { { "Authorization", "Bearer {token}" }, }, Content = new StringContent( "{\"name\": \"My Awesome Asset\", \"url\": \"https://example.com/my_asset_to_upload.jpg\"}", Encoding.UTF8, "application/json" ), }; using (var response = await client.SendAsync(request)) { response.EnsureSuccessStatusCode(); var body = await response.Content.ReadAsStringAsync(); Console.WriteLine(body); }; ``` ```go package main import ( "fmt" "io" "net/http" "strings" ) func main() { payload := strings.NewReader(`{ "name": "My Awesome Asset", "url": "https://example.com/my_asset_to_upload.jpg" }`) url := "https://api.canva.com/rest/v1/url-asset-uploads" req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "Bearer {token}") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```php $curl = curl_init(); curl_setopt_array($curl, array( CURLOPT_URL => "https://api.canva.com/rest/v1/url-asset-uploads", CURLOPT_CUSTOMREQUEST => "POST", CURLOPT_RETURNTRANSFER => true, CURLOPT_HTTPHEADER => array( 'Authorization: Bearer {token}', 'Content-Type: application/json', ), CURLOPT_POSTFIELDS => json_encode([ "name" => "My Awesome Asset", "url" => "https://example.com/my_asset_to_upload.jpg" ]) )); $response = curl_exec($curl); $err = curl_error($curl); curl_close($curl); if (empty($err)) { echo $response; } else { echo "Error: " . $err; } ``` ```ruby require 'net/http' require 'uri' url = URI('https://api.canva.com/rest/v1/url-asset-uploads') http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request['Authorization'] = 'Bearer {token}' request['Content-Type'] = 'application/json' request.body = < ## Success response If successful, the endpoint returns a `200` response with a JSON body with the following parameters: The status of the asset upload job. Properties of job} defaultExpanded={true}> The ID of the asset upload job. Status of the asset upload job. **Available values:** * `failed` * `in_progress` * `success` If the upload fails, this object provides details about the error. Properties of error}> A short string indicating why the upload failed. This field can be used to handle errors programmatically. **Available values:** * `file_too_big` * `import_failed` * `fetch_failed` A human-readable description of what went wrong. The asset object, which contains metadata about the asset. Properties of asset}> Type of an asset. **Available values:** * `image` * `video` The ID of the asset. The name of the asset. The user-facing tags attached to the asset. Users can add these tags to their uploaded assets, and they can search their uploaded assets in the Canva UI by searching for these tags. For information on how users use tags, see the [Canva Help Center page on asset tags](https://www.canva.com/help/add-edit-tags/). When the asset was added to Canva, as a Unix timestamp (in seconds since the Unix Epoch). When the asset was last updated in Canva, as a Unix timestamp (in seconds since the Unix Epoch). Metadata for the user, consisting of the User ID and Team ID. Properties of owner}> The ID of the user. The ID of the user's Canva Team. A thumbnail image representing the object. Properties of thumbnail}> The width of the thumbnail image in pixels. The height of the thumbnail image in pixels. A URL for retrieving the thumbnail image. This URL expires after 15 minutes. This URL includes a query string that's required for retrieving the thumbnail. Type-specific metadata for the asset. **Available values:** The only valid value is `image`. The width of the image in pixels. The height of the image in pixels. AI-generated tags for the image. **Available values:** The only valid value is `video`. The width of the video in pixels. The height of the video in pixels. The duration of the video in seconds. The import status of the asset. Properties of import_status}> State of the import job for an uploaded asset. **Available values:** * `failed` * `in_progress` * `success` If the import fails, this object provides details about the error. Properties of error}> A human-readable description of what went wrong. A short string indicating why the upload failed. This field can be used to handle errors programmatically. **Available values:** * `file_too_big` * `import_failed` ## Example responses ### In progress job ```json { "job": { "id": "e08861ae-3b29-45db-8dc1-1fe0bf7f1cc8", "status": "in_progress" } } ``` ### Successfully completed job ```json { "job": { "id": "e08861ae-3b29-45db-8dc1-1fe0bf7f1cc8", "status": "success", "asset": { "id": "Msd59349ff", "type": "image", "name": "My Awesome Upload", "tags": [ "image", "holiday", "best day ever" ], "owner": { "user_id": "oU123456AbCdE", "team_id": "oB123456AbCdE" }, "created_at": 1377396000, "updated_at": 1692928800, "thumbnail": { "width": 595, "height": 335, "url": "https://document-export.canva.com/Vczz9/zF9vzVtdADc/2/thumbnail/0001.png?" } } } } ``` ### Failed job ```json { "job": { "id": "e08861ae-3b29-45db-8dc1-1fe0bf7f1cc8", "status": "failed", "error": { "code": "file_too_big", "message": "Failed to import because the file is too big" } } } ``` ## Error responses ### 400 Bad Request A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see [Error responses](/docs/apps/rest-apis/error-responses/). A human-readable description of what went wrong. #### Example error responses ##### The provided URL is invalid ```json { "code": "invalid_field", "message": "'url' provided is invalid." } ``` ##### An asset upload for the URL already exists ```json { "code": "invalid_request", "message": "Asset Upload for url {url} already exists" } ``` ### 404 Not Found A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see [Error responses](/docs/apps/rest-apis/error-responses/). A human-readable description of what went wrong. #### Example error response ##### Job with ID not found ```json { "code": "not_found", "message": "Job with Id {jobId} not found" } ```